unit ListPop;

interface

//  MENEWL - 12.17.97  ( added the HINTS OFF )
{$HINTS OFF}

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls, TypInfo, Inspect;

type
  TListScreen = class(TForm)
    ListBox1: TListBox;
    procedure ListBox1MouseUp(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Integer);
    procedure ListBox1MouseDown(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Integer);
    procedure ListBox1Exit(Sender: TObject);
    procedure FormShow(Sender: TObject);
    procedure FormHide(Sender: TObject);
    procedure FormPaint(Sender: TObject);
    procedure FormMouseDown(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Integer);
    procedure FormMouseMove(Sender: TObject; Shift: TShiftState; X,
      Y: Integer);
    procedure FormCreate(Sender: TObject);
  private
    { Private declarations }
    f_Inspector : tf_Inspector;
    oldEvent : TNotifyEvent;
    BtnDown : Boolean;
    procedure LostControl(Sender : TObject);
  public
    Underneath : TBitmap;
    { Public declarations }
  end;

    Var ListScreen : TListScreen;
implementation
{$R *.DFM}

procedure TListScreen.ListBox1MouseUp(Sender: TObject;
  Button: TMouseButton; Shift: TShiftState; X, Y: Integer);
var P : TPoint;
    PPED : PPropEditData;
    ti : ptypeInfo;
begin
  if not btnDown then Begin
    SendMessage(ListBox1.Handle, wm_LButtonDown, mk_Lbutton,
      y shl 16 + x);
    sendMessage(ListBox1.Handle, wm_LButtonUp, mk_Lbutton,
      y shl 16 + x);
  End;
    PPED := Pointer((Owner as Tf_Inspector).
      ListBox1.Items.Objects[(Owner as Tf_Inspector).ListBox1.ItemIndex]);
  If PPED^.Kind = peProp then Begin

//  ti := GetTypeData(PPED^.PropData^.PropType);
    SetOrdProp(PPED^.Ob, PPED^.PropData,
       GetEnumValue(PPED^.PropData^.proptype^, ListBox1.Items[listBox1.ItemIndex]));

{    SetOrdProp(PPED^.Ob, PPED^.PropData,
      GetTypeData(@PPED^.PropData^.PropType)^.
      Minvalue + ListBox1.ItemIndex);
}  End;
  Close;
end;

Procedure TListScreen.LostControl(Sender : TObject);
Begin
  If Screen.ActiveForm <> Self then
  Close;
End;

procedure TListScreen.ListBox1MouseDown(Sender: TObject;
  Button: TMouseButton; Shift: TShiftState; X, Y: Integer);
var R : TRect;
begin
  If (X >= ClientRect.left) and (X <= ClientRect.Right) and
     (y >= ClientRect.Top) and (Y <= ClientRect.Bottom) then Begin
    BtnDown := True;
  End Else Begin
  End;
end;

procedure TListScreen.ListBox1Exit(Sender: TObject);
begin
  Close;
end;

procedure TListScreen.FormShow(Sender: TObject);
begin
  OldEvent := Screen.OnActiveFormChange;
  Screen.OnActiveFormChange := LostControl;
  BtnDown := False;
end;

procedure TListScreen.FormHide(Sender: TObject);
begin
  Screen.OnActiveFormChange := OldEvent;
  f_Inspector.CBDown := False;
  Underneath.Free;
end;

procedure TListScreen.FormPaint(Sender: TObject);
var r : trect;
begin
  r.left := 0;  r.top := 0;  r.right := underneath.width;
  r.bottom := underneath.height;
  Canvas.CopyRect(r, underneath.canvas, r);
end;

procedure TListScreen.FormMouseDown(Sender: TObject; Button: TMouseButton;
  Shift: TShiftState; X, Y: Integer);
Var R : Trect;
begin
  R := (Owner as tf_Inspector).ComboButtonBox;
  MapWindowPoints((Owner as tf_Inspector).ListBox1.handle, Handle, R, 2);
  If Not ((X >= R.left) and (X <= R.Right) and
     (y >= R.Top) and (Y <= R.Bottom)) then Begin
       R.Left := x;
       r.top := y;
       mapWindowPoints(Handle, (Owner as tf_Inspector).ListBox1.handle,
       r, 1);
       SendMessage((Owner as tf_Inspector).ListBox1.handle, WM_LbuttonDown,
       MK_LButton, r.top shl 16 + r.Left);
     End;
  Close;
end;

procedure TListScreen.FormMouseMove(Sender: TObject; Shift: TShiftState; X,
  Y: Integer);
Var R : Trect;
begin
  R := (Owner as tf_Inspector).ComboButtonBox;
  MapWindowPoints((Owner as tf_Inspector).ListBox1.handle, Handle, R, 2);
  If (X >= R.left) and (X <= R.Right) and
     (y >= R.Top) and (Y <= R.Bottom) then Cursor := crDefault
   else cursor := crIBeam;
end;

procedure TListScreen.FormCreate(Sender: TObject);
begin
  f_Inspector := Owner as tf_Inspector;
end;

end.

